PKCS11_DEFINE_STRUCT(CK_VERSION);
PKCS11_DEFINE_MEMBER(CK_VERSION, major);
PKCS11_DEFINE_MEMBER(CK_VERSION, minor);

PKCS11_DEFINE_STRUCT(CK_INFO);
PKCS11_DEFINE_MEMBER(CK_INFO, cryptokiVersion);
PKCS11_DEFINE_MEMBER(CK_INFO, manufacturerID);
PKCS11_DEFINE_MEMBER(CK_INFO, flags);
PKCS11_DEFINE_MEMBER(CK_INFO, libraryDescription);
PKCS11_DEFINE_MEMBER(CK_INFO, libraryVersion);

PKCS11_DEFINE_STRUCT(CK_SLOT_INFO);
PKCS11_DEFINE_MEMBER(CK_SLOT_INFO, slotDescription);
PKCS11_DEFINE_MEMBER(CK_SLOT_INFO, manufacturerID);
PKCS11_DEFINE_MEMBER(CK_SLOT_INFO, flags);
PKCS11_DEFINE_MEMBER(CK_SLOT_INFO, hardwareVersion);
PKCS11_DEFINE_MEMBER(CK_SLOT_INFO, firmwareVersion);

PKCS11_DEFINE_STRUCT(CK_TOKEN_INFO);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, label);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, manufacturerID);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, model);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, serialNumber);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, flags);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulMaxSessionCount);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulSessionCount);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulMaxRwSessionCount);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulRwSessionCount);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulMaxPinLen);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulMinPinLen);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulTotalPublicMemory);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulFreePublicMemory);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulTotalPrivateMemory);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, ulFreePrivateMemory);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, hardwareVersion);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, firmwareVersion);
PKCS11_DEFINE_MEMBER(CK_TOKEN_INFO, utcTime);

PKCS11_DEFINE_STRUCT(CK_SESSION_INFO);
PKCS11_DEFINE_MEMBER(CK_SESSION_INFO, slotID);
PKCS11_DEFINE_MEMBER(CK_SESSION_INFO, state);
PKCS11_DEFINE_MEMBER(CK_SESSION_INFO, flags);
PKCS11_DEFINE_MEMBER(CK_SESSION_INFO, ulDeviceError);

PKCS11_DEFINE_STRUCT(CK_DATE);
PKCS11_DEFINE_MEMBER(CK_DATE, year);
PKCS11_DEFINE_MEMBER(CK_DATE, month);
PKCS11_DEFINE_MEMBER(CK_DATE, day);

PKCS11_DEFINE_STRUCT(CK_MECHANISM_INFO);
PKCS11_DEFINE_MEMBER(CK_MECHANISM_INFO, ulMinKeySize);
PKCS11_DEFINE_MEMBER(CK_MECHANISM_INFO, ulMaxKeySize);
PKCS11_DEFINE_MEMBER(CK_MECHANISM_INFO, flags);

PKCS11_DEFINE_STRUCT(CK_C_INITIALIZE_ARGS);
PKCS11_DEFINE_MEMBER(CK_C_INITIALIZE_ARGS, pReserved);
/* unimplemented attr CK_CREATEMUTEX CreateMutex  */
/* unimplemented attr CK_DESTROYMUTEX DestroyMutex  */
/* unimplemented attr CK_LOCKMUTEX LockMutex  */
/* unimplemented attr CK_UNLOCKMUTEX UnlockMutex  */
PKCS11_DEFINE_MEMBER(CK_C_INITIALIZE_ARGS, flags);

PKCS11_DEFINE_STRUCT(CK_RSA_PKCS_OAEP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RSA_PKCS_OAEP_PARAMS, pSourceData);
PKCS11_DEFINE_MEMBER(CK_RSA_PKCS_OAEP_PARAMS, hashAlg);
PKCS11_DEFINE_MEMBER(CK_RSA_PKCS_OAEP_PARAMS, mgf);
PKCS11_DEFINE_MEMBER(CK_RSA_PKCS_OAEP_PARAMS, source);

PKCS11_DEFINE_STRUCT(CK_RSA_PKCS_PSS_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RSA_PKCS_PSS_PARAMS, hashAlg);
PKCS11_DEFINE_MEMBER(CK_RSA_PKCS_PSS_PARAMS, mgf);
PKCS11_DEFINE_MEMBER(CK_RSA_PKCS_PSS_PARAMS, sLen);

PKCS11_DEFINE_STRUCT(CK_ECDH1_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_ECDH1_DERIVE_PARAMS, pSharedData);
PKCS11_DEFINE_MEMBER(CK_ECDH1_DERIVE_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_ECDH1_DERIVE_PARAMS, kdf);

PKCS11_DEFINE_STRUCT(CK_ECMQV_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, pSharedData);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, pPublicData2);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, kdf);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, ulPrivateDataLen);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, hPrivateData);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, ulPublicDataLen2);
PKCS11_DEFINE_MEMBER(CK_ECMQV_DERIVE_PARAMS, publicKey);

PKCS11_DEFINE_STRUCT(CK_X9_42_DH1_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH1_DERIVE_PARAMS, pOtherInfo);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH1_DERIVE_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH1_DERIVE_PARAMS, kdf);

PKCS11_DEFINE_STRUCT(CK_X9_42_DH2_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH2_DERIVE_PARAMS, pOtherInfo);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH2_DERIVE_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH2_DERIVE_PARAMS, pPublicData2);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH2_DERIVE_PARAMS, kdf);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH2_DERIVE_PARAMS, ulPrivateDataLen);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH2_DERIVE_PARAMS, hPrivateData);
PKCS11_DEFINE_MEMBER(CK_X9_42_DH2_DERIVE_PARAMS, ulPublicDataLen2);

PKCS11_DEFINE_STRUCT(CK_X9_42_MQV_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, pOtherInfo);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, pPublicData2);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, kdf);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, ulPrivateDataLen);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, hPrivateData);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, ulPublicDataLen2);
PKCS11_DEFINE_MEMBER(CK_X9_42_MQV_DERIVE_PARAMS, publicKey);

PKCS11_DEFINE_STRUCT(CK_KEA_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_KEA_DERIVE_PARAMS, pRandomA);
PKCS11_DEFINE_MEMBER(CK_KEA_DERIVE_PARAMS, pRandomB);
PKCS11_DEFINE_MEMBER(CK_KEA_DERIVE_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_KEA_DERIVE_PARAMS, isSender);
PKCS11_DEFINE_MEMBER(CK_KEA_DERIVE_PARAMS, ulRandomLen);

PKCS11_DEFINE_STRUCT(CK_RC2_CBC_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RC2_CBC_PARAMS, ulEffectiveBits);
PKCS11_DEFINE_MEMBER(CK_RC2_CBC_PARAMS, iv);

PKCS11_DEFINE_STRUCT(CK_RC2_MAC_GENERAL_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RC2_MAC_GENERAL_PARAMS, ulEffectiveBits);
PKCS11_DEFINE_MEMBER(CK_RC2_MAC_GENERAL_PARAMS, ulMacLength);

PKCS11_DEFINE_STRUCT(CK_RC5_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RC5_PARAMS, ulWordsize);
PKCS11_DEFINE_MEMBER(CK_RC5_PARAMS, ulRounds);

PKCS11_DEFINE_STRUCT(CK_RC5_CBC_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RC5_CBC_PARAMS, pIv);
PKCS11_DEFINE_MEMBER(CK_RC5_CBC_PARAMS, ulWordsize);
PKCS11_DEFINE_MEMBER(CK_RC5_CBC_PARAMS, ulRounds);

PKCS11_DEFINE_STRUCT(CK_RC5_MAC_GENERAL_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RC5_MAC_GENERAL_PARAMS, ulWordsize);
PKCS11_DEFINE_MEMBER(CK_RC5_MAC_GENERAL_PARAMS, ulRounds);
PKCS11_DEFINE_MEMBER(CK_RC5_MAC_GENERAL_PARAMS, ulMacLength);

PKCS11_DEFINE_STRUCT(CK_DES_CBC_ENCRYPT_DATA_PARAMS);
PKCS11_DEFINE_MEMBER(CK_DES_CBC_ENCRYPT_DATA_PARAMS, pData);
PKCS11_DEFINE_MEMBER(CK_DES_CBC_ENCRYPT_DATA_PARAMS, iv);

PKCS11_DEFINE_STRUCT(CK_AES_CBC_ENCRYPT_DATA_PARAMS);
PKCS11_DEFINE_MEMBER(CK_AES_CBC_ENCRYPT_DATA_PARAMS, pData);
PKCS11_DEFINE_MEMBER(CK_AES_CBC_ENCRYPT_DATA_PARAMS, iv);

PKCS11_DEFINE_STRUCT(CK_SKIPJACK_PRIVATE_WRAP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, pPassword);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, pRandomA);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, pPrimeP);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, pBaseG);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, pSubprimeQ);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, ulPAndGLen);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, ulQLen);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_PRIVATE_WRAP_PARAMS, ulRandomLen);

PKCS11_DEFINE_STRUCT(CK_SKIPJACK_RELAYX_PARAMS);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, pOldWrappedX);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, pOldPassword);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, pOldPublicData);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, pOldRandomA);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, pNewPassword);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, pNewPublicData);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, pNewRandomA);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, ulOldRandomLen);
PKCS11_DEFINE_MEMBER(CK_SKIPJACK_RELAYX_PARAMS, ulNewRandomLen);

PKCS11_DEFINE_STRUCT(CK_PBE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_PBE_PARAMS, pInitVector);
PKCS11_DEFINE_MEMBER(CK_PBE_PARAMS, pPassword);
PKCS11_DEFINE_MEMBER(CK_PBE_PARAMS, pSalt);
PKCS11_DEFINE_MEMBER(CK_PBE_PARAMS, ulIteration);

PKCS11_DEFINE_STRUCT(CK_KEY_WRAP_SET_OAEP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_KEY_WRAP_SET_OAEP_PARAMS, pX);
PKCS11_DEFINE_MEMBER(CK_KEY_WRAP_SET_OAEP_PARAMS, bBC);

PKCS11_DEFINE_STRUCT(CK_SSL3_RANDOM_DATA);
PKCS11_DEFINE_MEMBER(CK_SSL3_RANDOM_DATA, pClientRandom);
PKCS11_DEFINE_MEMBER(CK_SSL3_RANDOM_DATA, pServerRandom);

PKCS11_DEFINE_STRUCT(CK_SSL3_MASTER_KEY_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_SSL3_MASTER_KEY_DERIVE_PARAMS, RandomInfo);
PKCS11_DEFINE_MEMBER(CK_SSL3_MASTER_KEY_DERIVE_PARAMS, pVersion);

PKCS11_DEFINE_STRUCT(CK_SSL3_KEY_MAT_OUT);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_OUT, pIVClient);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_OUT, pIVServer);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_OUT, hClientMacSecret);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_OUT, hServerMacSecret);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_OUT, hClientKey);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_OUT, hServerKey);

PKCS11_DEFINE_STRUCT(CK_SSL3_KEY_MAT_PARAMS);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_PARAMS, ulMacSizeInBits);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_PARAMS, ulKeySizeInBits);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_PARAMS, ulIVSizeInBits);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_PARAMS, bIsExport);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_PARAMS, RandomInfo);
PKCS11_DEFINE_MEMBER(CK_SSL3_KEY_MAT_PARAMS, pReturnedKeyMaterial);

PKCS11_DEFINE_STRUCT(CK_WTLS_RANDOM_DATA);
PKCS11_DEFINE_MEMBER(CK_WTLS_RANDOM_DATA, pClientRandom);
PKCS11_DEFINE_MEMBER(CK_WTLS_RANDOM_DATA, pServerRandom);

PKCS11_DEFINE_STRUCT(CK_WTLS_MASTER_KEY_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_WTLS_MASTER_KEY_DERIVE_PARAMS, pVersion);
PKCS11_DEFINE_MEMBER(CK_WTLS_MASTER_KEY_DERIVE_PARAMS, DigestMechanism);
PKCS11_DEFINE_MEMBER(CK_WTLS_MASTER_KEY_DERIVE_PARAMS, RandomInfo);

PKCS11_DEFINE_STRUCT(CK_WTLS_PRF_PARAMS);
PKCS11_DEFINE_MEMBER(CK_WTLS_PRF_PARAMS, pSeed);
PKCS11_DEFINE_MEMBER(CK_WTLS_PRF_PARAMS, pLabel);
PKCS11_DEFINE_MEMBER(CK_WTLS_PRF_PARAMS, pOutput);
PKCS11_DEFINE_MEMBER(CK_WTLS_PRF_PARAMS, DigestMechanism);
PKCS11_DEFINE_MEMBER(CK_WTLS_PRF_PARAMS, pulOutputLen);

PKCS11_DEFINE_STRUCT(CK_WTLS_KEY_MAT_OUT);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_OUT, pIV);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_OUT, hMacSecret);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_OUT, hKey);

PKCS11_DEFINE_STRUCT(CK_WTLS_KEY_MAT_PARAMS);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, DigestMechanism);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, ulMacSizeInBits);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, ulKeySizeInBits);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, ulIVSizeInBits);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, ulSequenceNumber);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, bIsExport);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, RandomInfo);
PKCS11_DEFINE_MEMBER(CK_WTLS_KEY_MAT_PARAMS, pReturnedKeyMaterial);

PKCS11_DEFINE_STRUCT(CK_CMS_SIG_PARAMS);
PKCS11_DEFINE_MEMBER(CK_CMS_SIG_PARAMS, pContentType);
PKCS11_DEFINE_MEMBER(CK_CMS_SIG_PARAMS, pRequestedAttributes);
PKCS11_DEFINE_MEMBER(CK_CMS_SIG_PARAMS, pRequiredAttributes);
PKCS11_DEFINE_MEMBER(CK_CMS_SIG_PARAMS, certificateHandle);
PKCS11_DEFINE_MEMBER(CK_CMS_SIG_PARAMS, pSigningMechanism);
PKCS11_DEFINE_MEMBER(CK_CMS_SIG_PARAMS, pDigestMechanism);

PKCS11_DEFINE_STRUCT(CK_KEY_DERIVATION_STRING_DATA);
PKCS11_DEFINE_MEMBER(CK_KEY_DERIVATION_STRING_DATA, pData);

PKCS11_DEFINE_STRUCT(CK_PKCS5_PBKD2_PARAMS);
PKCS11_DEFINE_MEMBER(CK_PKCS5_PBKD2_PARAMS, pSaltSourceData);
PKCS11_DEFINE_MEMBER(CK_PKCS5_PBKD2_PARAMS, pPrfData);
PKCS11_DEFINE_MEMBER(CK_PKCS5_PBKD2_PARAMS, pPassword);
PKCS11_DEFINE_MEMBER(CK_PKCS5_PBKD2_PARAMS, saltSource);
PKCS11_DEFINE_MEMBER(CK_PKCS5_PBKD2_PARAMS, iterations);
PKCS11_DEFINE_MEMBER(CK_PKCS5_PBKD2_PARAMS, prf);
PKCS11_DEFINE_MEMBER(CK_PKCS5_PBKD2_PARAMS, ulPasswordLen);

PKCS11_DEFINE_STRUCT(CK_OTP_PARAM);
PKCS11_DEFINE_MEMBER(CK_OTP_PARAM, pValue);
PKCS11_DEFINE_MEMBER(CK_OTP_PARAM, type);

PKCS11_DEFINE_STRUCT(CK_OTP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_OTP_PARAMS, pParams);

PKCS11_DEFINE_STRUCT(CK_OTP_SIGNATURE_INFO);
PKCS11_DEFINE_MEMBER(CK_OTP_SIGNATURE_INFO, pParams);

PKCS11_DEFINE_STRUCT(CK_KIP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_KIP_PARAMS, pSeed);
PKCS11_DEFINE_MEMBER(CK_KIP_PARAMS, pMechanism);
PKCS11_DEFINE_MEMBER(CK_KIP_PARAMS, hKey);

PKCS11_DEFINE_STRUCT(CK_AES_CTR_PARAMS);
PKCS11_DEFINE_MEMBER(CK_AES_CTR_PARAMS, ulCounterBits);
PKCS11_DEFINE_MEMBER(CK_AES_CTR_PARAMS, cb);

PKCS11_DEFINE_STRUCT(CK_GCM_PARAMS);
PKCS11_DEFINE_MEMBER(CK_GCM_PARAMS, pIv);
PKCS11_DEFINE_MEMBER(CK_GCM_PARAMS, pAAD);
PKCS11_DEFINE_MEMBER(CK_GCM_PARAMS, ulIvBits);
PKCS11_DEFINE_MEMBER(CK_GCM_PARAMS, ulTagBits);

PKCS11_DEFINE_STRUCT(CK_CCM_PARAMS);
PKCS11_DEFINE_MEMBER(CK_CCM_PARAMS, pNonce);
PKCS11_DEFINE_MEMBER(CK_CCM_PARAMS, pAAD);
PKCS11_DEFINE_MEMBER(CK_CCM_PARAMS, ulDataLen);
PKCS11_DEFINE_MEMBER(CK_CCM_PARAMS, ulMACLen);

PKCS11_DEFINE_STRUCT(CK_CAMELLIA_CBC_ENCRYPT_DATA_PARAMS);
PKCS11_DEFINE_MEMBER(CK_CAMELLIA_CBC_ENCRYPT_DATA_PARAMS, pData);
PKCS11_DEFINE_MEMBER(CK_CAMELLIA_CBC_ENCRYPT_DATA_PARAMS, iv);

PKCS11_DEFINE_STRUCT(CK_ARIA_CBC_ENCRYPT_DATA_PARAMS);
PKCS11_DEFINE_MEMBER(CK_ARIA_CBC_ENCRYPT_DATA_PARAMS, pData);
PKCS11_DEFINE_MEMBER(CK_ARIA_CBC_ENCRYPT_DATA_PARAMS, iv);

PKCS11_DEFINE_STRUCT(CK_DSA_PARAMETER_GEN_PARAM);
PKCS11_DEFINE_MEMBER(CK_DSA_PARAMETER_GEN_PARAM, pSeed);
PKCS11_DEFINE_MEMBER(CK_DSA_PARAMETER_GEN_PARAM, hash);
PKCS11_DEFINE_MEMBER(CK_DSA_PARAMETER_GEN_PARAM, ulIndex);

PKCS11_DEFINE_STRUCT(CK_ECDH_AES_KEY_WRAP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_ECDH_AES_KEY_WRAP_PARAMS, pSharedData);
PKCS11_DEFINE_MEMBER(CK_ECDH_AES_KEY_WRAP_PARAMS, ulAESKeyBits);
PKCS11_DEFINE_MEMBER(CK_ECDH_AES_KEY_WRAP_PARAMS, kdf);

PKCS11_DEFINE_STRUCT(CK_RSA_AES_KEY_WRAP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_RSA_AES_KEY_WRAP_PARAMS, ulAESKeyBits);
PKCS11_DEFINE_MEMBER(CK_RSA_AES_KEY_WRAP_PARAMS, pOAEPParams);

PKCS11_DEFINE_STRUCT(CK_TLS12_MASTER_KEY_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_TLS12_MASTER_KEY_DERIVE_PARAMS, RandomInfo);
PKCS11_DEFINE_MEMBER(CK_TLS12_MASTER_KEY_DERIVE_PARAMS, pVersion);
PKCS11_DEFINE_MEMBER(CK_TLS12_MASTER_KEY_DERIVE_PARAMS, prfHashMechanism);

PKCS11_DEFINE_STRUCT(CK_TLS12_KEY_MAT_PARAMS);
PKCS11_DEFINE_MEMBER(CK_TLS12_KEY_MAT_PARAMS, ulMacSizeInBits);
PKCS11_DEFINE_MEMBER(CK_TLS12_KEY_MAT_PARAMS, ulKeySizeInBits);
PKCS11_DEFINE_MEMBER(CK_TLS12_KEY_MAT_PARAMS, ulIVSizeInBits);
PKCS11_DEFINE_MEMBER(CK_TLS12_KEY_MAT_PARAMS, bIsExport);
PKCS11_DEFINE_MEMBER(CK_TLS12_KEY_MAT_PARAMS, RandomInfo);
PKCS11_DEFINE_MEMBER(CK_TLS12_KEY_MAT_PARAMS, pReturnedKeyMaterial);
PKCS11_DEFINE_MEMBER(CK_TLS12_KEY_MAT_PARAMS, prfHashMechanism);

PKCS11_DEFINE_STRUCT(CK_TLS_KDF_PARAMS);
PKCS11_DEFINE_MEMBER(CK_TLS_KDF_PARAMS, pLabel);
PKCS11_DEFINE_MEMBER(CK_TLS_KDF_PARAMS, pContextData);
PKCS11_DEFINE_MEMBER(CK_TLS_KDF_PARAMS, prfMechanism);
PKCS11_DEFINE_MEMBER(CK_TLS_KDF_PARAMS, ulLabelLength);
PKCS11_DEFINE_MEMBER(CK_TLS_KDF_PARAMS, RandomInfo);
PKCS11_DEFINE_MEMBER(CK_TLS_KDF_PARAMS, ulContextDataLength);

PKCS11_DEFINE_STRUCT(CK_TLS_MAC_PARAMS);
PKCS11_DEFINE_MEMBER(CK_TLS_MAC_PARAMS, prfHashMechanism);
PKCS11_DEFINE_MEMBER(CK_TLS_MAC_PARAMS, ulMacLength);
PKCS11_DEFINE_MEMBER(CK_TLS_MAC_PARAMS, ulServerOrClient);

PKCS11_DEFINE_STRUCT(CK_GOSTR3410_DERIVE_PARAMS);
PKCS11_DEFINE_MEMBER(CK_GOSTR3410_DERIVE_PARAMS, pPublicData);
PKCS11_DEFINE_MEMBER(CK_GOSTR3410_DERIVE_PARAMS, pUKM);
PKCS11_DEFINE_MEMBER(CK_GOSTR3410_DERIVE_PARAMS, kdf);

PKCS11_DEFINE_STRUCT(CK_GOSTR3410_KEY_WRAP_PARAMS);
PKCS11_DEFINE_MEMBER(CK_GOSTR3410_KEY_WRAP_PARAMS, pWrapOID);
PKCS11_DEFINE_MEMBER(CK_GOSTR3410_KEY_WRAP_PARAMS, pUKM);
PKCS11_DEFINE_MEMBER(CK_GOSTR3410_KEY_WRAP_PARAMS, hKey);

